unit MirroringMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, system.Types;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    HMirroring: TButton;
    VMirroring: TButton;
    RadioGroup1: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HMirroringClick(Sender: TObject);
    procedure VMirroringClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    procedure Allimagecopy;
    procedure HImgeCopy;
    procedure VImgeCopy;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarry  = ^TPrgbarry;                     // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B

implementation

{$R *.dfm}
const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;                            // \gTCY

var
  GHeight, GWidth : integer;
  Vrect           : Trect;
  InBitmap        : TBitmap;
  OutBitmap       : TBitmap;
  Origin          : TPoint;
  EndPoint        : TPoint;
  Drawing         : Boolean;
  NewMove         : Boolean;
  OX, EX, OY, EY  : Integer;
  IHeight         : Integer;
  IWidth          : Integer;
  SWidth          : integer;                    // Tv摜
  SHeight         : integer;                    // Tv摜


procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  HMirroring.Enabled := False;
  VMirroring.Enabled := False;
  RadioGroup1.Enabled := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clBtnface;
  Image2.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        Image2.Width := IWidth;
        Image2.Height:= IHeight;
        Image2.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width  := GWidth;
        InBitmap.Height := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width  := GWidth;
        OutBitmap.Height := GHeight;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  HMirroring.Enabled := True;
  VMirroring.Enabled := True;
  RadioGroup1.Enabled := True;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Drawing := True;
  with Image1.Canvas do begin                                 // }EX_EtOZbg
    Brush.Color := clWhite;
    Brush.Style := bsClear;
    Pen.Color := ClBlack;
    Pen.Width := 2;
  end;
  Origin := Point(X, Y);                                      // W̕ۑ
  NewMove := True;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Drawing and (Shift = [ssLeft]) then begin
    With Image1.Canvas do begin
      Pen.Mode := pmNotXor;                                   // y[h Not Xor
      if not NewMove then begin
        MoveTo(Origin.X, Origin.Y);                           // O̐
        LineTo(EndPoint.X, Origin.Y);
        LineTo(EndPoint.X, EndPoint.Y);
        LineTo(Origin.X, EndPoint.Y);
        LineTo(Origin.X, Origin.Y);                           // O̐
      end;
      EndPoint := point(X, Y);                                // VWۑ
      MoveTo(Origin.X, Origin.Y);                             // 
      LineTo(EndPoint.X, Origin.Y);
      LineTo(EndPoint.X, EndPoint.Y);
      LineTo(Origin.X, EndPoint.Y);
      LineTo(Origin.X, Origin.Y);                             // 
      NewMove := False;
      Pen.Mode := pmCopy;
    end;                                                      // y[hʏ
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  TMPI        : integer;
  Scal        : Double;
begin
  if not Drawing or NewMove then exit;
  Image1.Canvas.Pen.Mode := pmNotXor;                         // y[h Not Xor
  Image1.Canvas.MoveTo(Origin.X, Origin.Y);                   // O̐
  Image1.Canvas.LineTo(EndPoint.X, Origin.Y);
  Image1.Canvas.LineTo(EndPoint.X, EndPoint.Y);
  Image1.Canvas.LineTo(Origin.X, EndPoint.Y);
  Image1.Canvas.LineTo(Origin.X, Origin.Y);                   // O̐
  Image1.Canvas.Pen.Mode := pmCopy;                           // y[hʏ
  NewMove := False;
  Drawing := False;
  // ͈͎w萳K֕ϊ
  if Origin.X > EndPoint.X then begin
    TMPI := Origin.X;
    Origin.X := EndPoint.X;
    EndPoint.X := TMPI;
  end;
  if Origin.Y > EndPoint.Y then begin
    TMPI := Origin.Y;
    Origin.Y := EndPoint.Y;
    EndPoint.Y := TMPI;
  end;
  IWidth  := Image1.Width;
  IHeight := Image1.Height;
  // }EX|Cg摜Wɕϊ
  Scal := GWidth / IWidth;                                    // 摜ƕ\摜̔{
  OX := Round(Origin.X * Scal);
  EX := Round(EndPoint.X * Scal);
  OY := Round(Origin.Y * Scal);
  EY := Round(EndPoint.Y * Scal);
  if OX < 0 then OX := 0;
  if EX > GWidth - 1 Then EX := GWidth - 1;
  if OY < 0 then OY := 0;
  if EY > GHeight - 1 then EY := GHeight - 1;
  // ͈̓TCYݒ
  SWidth  := EX - OX;
  SHeight := EY - OY;
  Allimagecopy;                                               // SCopy
  case RadioGroup1.ItemIndex of
    0: HImgeCopy;
    1: VImgeCopy;
  end;
end;

procedure TForm1.Allimagecopy;                                // SCopy
var
  I, J        : integer;
  OutPrgbarray  : Prgbarry;
  InpPrgbarray  : Prgbarry;
begin
  for I := 0 to GHeight - 1 do begin
    InpPrgbarray := InBitmap.ScanLine[I];
    OutPrgbarray := OutBitmap.ScanLine[I];
    for J := 0 to GWidth - 1 do begin
      OutPrgbarray[J] := InpPrgbarray[J];                     // PRs[
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

procedure TForm1.HImgeCopy;
var
  I, J        : integer;
  OutPrgbarray  : Prgbarry;
  InpPrgbarray  : Prgbarry;
begin
  for I := OY to EY do begin
    InpPrgbarray := InBitmap.ScanLine[I];
    OutPrgbarray := OutBitmap.ScanLine[I];
    for J := OX  to EX do begin
      OutPrgbarray[OX + EX - J] := InpPrgbarray[J];           // ̔ztɂăRs[
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

procedure TForm1.VImgeCopy;
var
  I, J        : integer;
  OutPrgbarray  : Prgbarry;
  InpPrgbarray  : Prgbarry;
begin
  for I := OY to EY do begin
    InpPrgbarray := InBitmap.ScanLine[I];
    OutPrgbarray := OutBitmap.ScanLine[OY + EY - I];          // c̔ztɂăRs[
    for J := OX  to EX do begin
      OutPrgbarray[J] := InpPrgbarray[J];
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

procedure TForm1.HMirroringClick(Sender: TObject);            // ~[
var
  I, J        : integer;
  M1Width     : integer;
  OutPrgbarray  : Prgbarry;
  InpPrgbarray  : Prgbarry;
begin
  M1Width := GWidth - 1;
  for I := 0 to GHeight - 1 do begin
    InpPrgbarray := InBitmap.ScanLine[I];
    OutPrgbarray := OutBitmap.ScanLine[I];
    for J := 0 to M1Width - 1 do begin
      OutPrgbarray[J] := InpPrgbarray[M1Width - J];           // ̔ztɂăRs[
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

procedure TForm1.VMirroringClick(Sender: TObject);            // c~[
var
  I, J        : integer;
  M1Height    : integer;
  OutPrgbarray  : Prgbarry;
  InpPrgbarray  : Prgbarry;
begin
  M1Height := GHeight - 1;
  for I := 0 to M1Height do begin
    InpPrgbarray := InBitmap.ScanLine[M1Height - I];          // c̔ztɂăRs[
    OutPrgbarray := OutBitmap.ScanLine[I];
    for J := 0 to GWidth - 1 do begin
      OutPrgbarray[J] := InpPrgbarray[J];
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  Image2.Width  := ImageHW;
  Image2.Height := ImageHW;
  InBitmap  := TBitmap.Create;
  OutBitmap := TBitmap.Create;
  InBitmap.PixelFormat  := pf24bit;                           // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat := pf24bit;                           // 24rbgJ[ɐݒ
  RadioGroup1.Caption := '͈͑I';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;


end.
